#!/usr/bin/perl -w

use strict;

# Converts QccPack CBK files into a SAM text code file.

#----------------------------------------------------------------------
# Decode header
$_ = <>;
die "Bad format" unless /^CBK0/;

$_ = <>;
my ($ncodes, $ncols) = /(\d+)\s+(\d+)/;


#----------------------------------------------------------------------
# Unpack CBK file
my @codes;
$/=undef;

# Need to byte swap floats - ugly!
my @f = unpack("f*", pack("N*", unpack("V*", <>)));

my $c = 0;
for (my $i = 0; $i < $ncodes; $i++) {
    for (my $j = 0; $j < $ncols; $j++) {
	$codes[$i][$j] = int($f[$c++]+.5);
    }
}

#-----------------------------------------------------------------------------
# Convert to codes.txt file
print "#EVTABLE 1.0\n";
print "#NREC $ncodes\n";
print "#MAXWORD 1\n";
print "#ALPHABET ACGT\n";

for (my $i = 0; $i < $ncodes; $i++) {
    print "$i\t0\t@{$codes[$i]}\n";
}


